package rwth.i2.ltlrv.afastate.interfaze;

import rwth.i2.ltlrv.formula.interfaze.IFormula;
import rwth.i2.ltlrv.formula.interfaze.IUnaryTerm;

/**
 * IUnaryAFAState - Common interface for unary AFA states.
 * 
 * @author Eric Bodden
 */
public interface IUnaryAFAState extends IUnaryTerm, IAFAState {
    
    /**
     * Creates a formula with the same operator as <code>this<code>
     * but a different subformula. This is used for recursion with
     * nondestructive updates.
     * @param subformula the new subformula
     * @return the new instance
     */
    public IAFAState reconstruct(IFormula subformula);

}
