package rwth.i2.ltlrv.formula.impl;

import rwth.i2.ltlrv.afastate.interfaze.IAFAState;
import rwth.i2.ltlrv.formula.base.UnaryFormula;
import rwth.i2.ltlrv.formula.interfaze.IFinally;
import rwth.i2.ltlrv.formula.interfaze.IFormula;

/**
 * Finally - Implements the <i>Finally</i> formula constructor of LTL.
 * 
 * @author Eric Bodden
 */
public class Finally extends UnaryFormula implements IFinally {

    /**
     * Constructs a new formula with the given subformula.
     * @param subFormula the subformula
     */
    public Finally(IFormula subFormula) {
        super(subFormula);
    }

    /**
     * {@inheritDoc}
     */
    public IAFAState negationNormalForm() {
        //F(sub) = (TT) U (sub)
        return factory.Until( factory.TT(), subformula ).negationNormalForm();
    }

    /**
     * {@inheritDoc}
     */
    public String symbol() {
        return "F";
    }
    
}
