package rwth.i2.ltlrv.formula.impl;

import rwth.i2.ltlrv.afastate.interfaze.IAFAState;
import rwth.i2.ltlrv.formula.base.UnaryFormula;
import rwth.i2.ltlrv.formula.interfaze.IFormula;
import rwth.i2.ltlrv.formula.interfaze.IGlobally;

/**
 * Globally - Implements the <i>Globally</i> formula constructor of LTL.
 * 
 * @author Eric Bodden
 */
public class Globally extends UnaryFormula implements IGlobally {

    /**
     * Constructs a new formula with the given subformula.
     * @param subFormula the subformula
     */
    public Globally(IFormula subFormula) {
        super(subFormula);
    }

    /**
     * {@inheritDoc}
     */
    public IAFAState negationNormalForm() {
        //G(sub) = (FF) R (sub) 
        return factory.Release(factory.FF(), subformula).negationNormalForm();
    }

    /**
     * {@inheritDoc}
     */
    public String symbol() {
        return "G";
    }
    
}
