package rwth.i2.ltlrv.management;

import rwth.i2.ltlrv.data.PropositionSet;

/**
 * @author Eric Bodden
 */
public class Debug {
	
	private final static boolean LOG_PROPOSITIONS = System.getProperty("JLO_LOG_PROPS")!=null;
	private final static boolean LOG_CONFIG = System.getProperty("JLO_LOG_CONFIG")!=null;

	/**
	 * @param formulaId
	 * @param currentPropositions
	 */
	public static void logPropositions(String formulaId, PropositionSet currentPropositions) {
        if(LOG_PROPOSITIONS) {
        	System.err.println("Transition triggered:");
        	System.err.println("Formula id:   "+formulaId);
        	System.err.println("Propositions:");
        	System.err.println(currentPropositions);
        }
	}

	/**
	 * @param formulaId 
	 * @param config
	 */
	public static void logConfig(String formulaId, Configuration config) {
        if(LOG_CONFIG) {
        	System.err.println("New configuration for formula "+formulaId+":");
        	System.err.println(config);
        }
	}

}
