package rwth.i2.ltlrv.management;

import general.AbstractTest;
import rwth.i2.ltlrv.afastate.interfaze.IAFAState;
import rwth.i2.ltlrv.afastate.interfaze.IAFAState.ValidationException;
import rwth.i2.ltlrv.data.PropositionSet;
import rwth.i2.ltlrv.formula.interfaze.IFormula;

/**
 * EvalAbstractEvaluationTest
 * 
 * @author Eric Bodden
 */
@SuppressWarnings("all")
public abstract class EvalAbstractEvaluationTest extends AbstractTest {

    protected PropositionSet props;
    
    protected Configuration config;
    
    protected final IAFAState formula; 
    
    public EvalAbstractEvaluationTest(IFormula formula) {
        this.formula = formula.negationNormalForm();
    }
    
    /*
     * @see TestCase#setUp()
     */
    @Override
    protected void setUp() throws Exception {
        props = new PropositionSet();
        try {
        	config = new Configuration(formula);
        } catch(ValidationException ex) {
        	System.err.println(ex);
        	ex.printStackTrace();
        	throw ex;
        }
        super.setUp();
    }
    
    /**
     * {@inheritDoc}
     */
    @Override
    public String toString() {
        return this.getClass().getSimpleName() + " [" +  
        ((config==null)?"Test not yet initialized.":config.toString())
        + "]";
    }

}
