package rwth.i2.ltlrv.management;


/**
 * EvalGlobalImplicationTest
 * 
 * @author Eric Bodden
 */
@SuppressWarnings("all")
public class EvalGlobalImplicationTest extends EvalAbstractEvaluationTest {

    public EvalGlobalImplicationTest() {
        super( f.G(f.Impl(p_a,f.F(q_a))) ); 
    }
    
    public void testSequential() {
        assertTrue(config.isFinal());

        props.add(f.Proposition("p",bindings_actual_a_1));
        config.transition(props);
        assertFalse(config.isFinal());
        
        props.clear();
        
        props.add(f.Proposition("q",bindings_actual_a_1));
        config.transition(props);
        assertTrue(config.isFinal());
    }
    
    public void testSameTime() {
        assertTrue(config.isFinal());

        props.add(f.Proposition("p",bindings_actual_a_1));
        props.add(f.Proposition("q",bindings_actual_a_1));
        config.transition(props);
        assertTrue(config.isFinal());
    }

    public void testInterleavingSequential() {
        assertTrue(config.isFinal());

        props.add(f.Proposition("p",bindings_actual_a_1));
        config.transition(props);
        assertFalse(config.isFinal());
        
        props.clear();
        
        props.add(f.Proposition("p",bindings_actual_a_2));
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();
        
        props.add(f.Proposition("q",bindings_actual_a_1));
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();
        
        props.add(f.Proposition("q",bindings_actual_a_2));
        config.transition(props);
        assertTrue(config.isFinal());
    }
    
    public void testInterleavingMirrored() {
        assertTrue(config.isFinal());

        props.add(f.Proposition("p",bindings_actual_a_1));
        config.transition(props);
        assertFalse(config.isFinal());
        
        props.clear();
        
        props.add(f.Proposition("p",bindings_actual_a_2));
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();
        
        props.add(f.Proposition("q",bindings_actual_a_2));
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();
        
        props.add(f.Proposition("q",bindings_actual_a_1));
        config.transition(props);
        assertTrue(config.isFinal());
    }
    
    public void testVerbose() {
        assertTrue(config.isFinal());

        props.clear();
        
        //{}
        config.transition(props);
        assertTrue(config.isFinal());
        
        props.clear();
        
        //{q3}
        props.add(f.Proposition("q",bindings_actual_a_3));
        config.transition(props);
        assertTrue(config.isFinal());

        props.clear();
        
        //{p1}
        props.add(f.Proposition("p",bindings_actual_a_1));
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();
        
        //{p1,p2}
        props.add(f.Proposition("p",bindings_actual_a_1));
        props.add(f.Proposition("p",bindings_actual_a_2));
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();
        
        //{}
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();
        
        //{q2}
        props.add(f.Proposition("q",bindings_actual_a_2));
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();
        
        //{q2,q3}
        props.add(f.Proposition("q",bindings_actual_a_2));
        props.add(f.Proposition("q",bindings_actual_a_3));
        config.transition(props);
        assertFalse(config.isFinal());

        props.clear();
    
        //{q1}
        props.add(f.Proposition("q",bindings_actual_a_1));
        config.transition(props);
        assertTrue(config.isFinal());
    }
}
