package rwth.i2.ltlrv.management;


/**
 * EvalNextTest
 * 
 * @author Eric Bodden
 */
@SuppressWarnings("all")
public class EvalNextTest extends EvalAbstractEvaluationTest {

    public EvalNextTest() {
        super( f.X(p_a) ); 
    }
    
    public void testPositive() {
        assertFalse(config.isFinal());

        //trigger transition once
        config.transition(props);
        
        props.add(f.Proposition("p",bindings_actual_a_1));
        config.transition(props);
        assertTrue(config.isFinal());
    }    

    public void testNegative() {
        assertFalse(config.isFinal());

        //trigger transition once
        config.transition(props);

        //no proposition here
        config.transition(props);
        assertFalse(config.isFinal());
    }
    
    public void testWrongArgument() {
        assertFalse(config.isFinal());

        //trigger transition once
        config.transition(props);

        props.add(f.Proposition("p",bindings_actual_b_1));
        config.transition(props);
        assertFalse(config.isFinal());
    }
    
}
